QCPCurve Class Reference
Author: Emanuel Eichhammer

· · · ·
Public Types | Public Functions | Protected Functions
QCPCurve Class Reference

A plottable representing a parametric curve in a plot. More...

Inheritance diagram for QCPCurve:

## Public Types
enum | LineStyle

## Public Functions
| QCPCurve (QCPAxis *keyAxis, QCPAxis *valueAxis)
QCPCurveDataMap * | data () const
QCPScatterStyle | scatterStyle () const
LineStyle | lineStyle () const
void | setData (QCPCurveDataMap *data, bool copy=false)
void | setData (const QVector< double > &t, const QVector< double > &key, const QVector< double > &value)
void | setData (const QVector< double > &key, const QVector< double > &value)
void | setScatterStyle (const QCPScatterStyle &style)
void | setLineStyle (LineStyle style)
void | addData (const QCPCurveDataMap &dataMap)
void | addData (const QCPCurveData &data)
void | addData (double t, double key, double value)
void | addData (double key, double value)
void | addData (const QVector< double > &ts, const QVector< double > &keys, const QVector< double > &values)
void | removeDataBefore (double t)
void | removeDataAfter (double t)
void | removeData (double fromt, double tot)
void | removeData (double t)
virtual void | clearData ()
virtual double | selectTest (const QPointF &pos, bool onlySelectable, QVariant *details=0) const
Public Functions inherited from QCPAbstractPlottable
| QCPAbstractPlottable (QCPAxis *keyAxis, QCPAxis *valueAxis)
QString | name () const
bool | antialiasedFill () const
bool | antialiasedScatters () const
bool | antialiasedErrorBars () const
QPen | pen () const
QPen | selectedPen () const
QBrush | brush () const
QBrush | selectedBrush () const
QCPAxis * | keyAxis () const
QCPAxis * | valueAxis () const
bool | selectable () const
bool | selected () const
void | setName (const QString &name)
void | setAntialiasedFill (bool enabled)
void | setAntialiasedScatters (bool enabled)
void | setAntialiasedErrorBars (bool enabled)
void | setPen (const QPen &pen)
void | setSelectedPen (const QPen &pen)
void | setBrush (const QBrush &brush)
void | setSelectedBrush (const QBrush &brush)
void | setKeyAxis (QCPAxis *axis)
void | setValueAxis (QCPAxis *axis)
Q_SLOT void | setSelectable (bool selectable)
Q_SLOT void | setSelected (bool selected)
virtual bool | addToLegend ()
virtual bool | removeFromLegend () const
void | rescaleAxes (bool onlyEnlarge=false) const
void | rescaleKeyAxis (bool onlyEnlarge=false) const
void | rescaleValueAxis (bool onlyEnlarge=false) const
Public Functions inherited from QCPLayerable
| QCPLayerable (QCustomPlot *plot, QString targetLayer=QString(), QCPLayerable *parentLayerable=0)
bool | visible () const
QCustomPlot * | parentPlot () const
QCPLayerable * | parentLayerable () const
QCPLayer * | layer () const
bool | antialiased () const
void | setVisible (bool on)
Q_SLOT bool | setLayer (QCPLayer *layer)
bool | setLayer (const QString &layerName)
void | setAntialiased (bool enabled)
bool | realVisibility () const

## Protected Functions
virtual void | draw (QCPPainter *painter)
virtual void | drawLegendIcon (QCPPainter *painter, const QRectF &rect) const
virtual QCPRange | getKeyRange (bool &foundRange, SignDomain inSignDomain=sdBoth) const
virtual QCPRange | getValueRange (bool &foundRange, SignDomain inSignDomain=sdBoth) const
virtual void | drawScatterPlot (QCPPainter *painter, const QVector< QPointF > *pointData) const
void | getCurveData (QVector< QPointF > *lineData) const
int | getRegion (double x, double y, double rectLeft, double rectTop, double rectRight, double rectBottom) const
QPointF | getOptimizedPoint (int prevRegion, double prevKey, double prevValue, double key, double value, double rectLeft, double rectTop, double rectRight, double rectBottom) const
QVector< QPointF > | getOptimizedCornerPoints (int prevRegion, int currentRegion, double prevKey, double prevValue, double key, double value, double rectLeft, double rectTop, double rectRight, double rectBottom) const
bool | mayTraverse (int prevRegion, int currentRegion) const
bool | getTraverse (double prevKey, double prevValue, double key, double value, double rectLeft, double rectTop, double rectRight, double rectBottom, QPointF &crossA, QPointF &crossB) const
void | getTraverseCornerPoints (int prevRegion, int currentRegion, double rectLeft, double rectTop, double rectRight, double rectBottom, QVector< QPointF > &beforeTraverse, QVector< QPointF > &afterTraverse) const
double | pointDistance (const QPointF &pixelPoint) const
Protected Functions inherited from QCPAbstractPlottable
virtual QRect | clipRect () const
virtual QCP::Interaction | selectionCategory () const
void | applyDefaultAntialiasingHint (QCPPainter *painter) const
virtual void | selectEvent (QMouseEvent *event, bool additive, const QVariant &details, bool *selectionStateChanged)
virtual void | deselectEvent (bool *selectionStateChanged)
void | coordsToPixels (double key, double value, double &x, double &y) const
const QPointF | coordsToPixels (double key, double value) const
void | pixelsToCoords (double x, double y, double &key, double &value) const
void | pixelsToCoords (const QPointF &pixelPos, double &key, double &value) const
QPen | mainPen () const
QBrush | mainBrush () const
void | applyFillAntialiasingHint (QCPPainter *painter) const
void | applyScattersAntialiasingHint (QCPPainter *painter) const
void | applyErrorBarsAntialiasingHint (QCPPainter *painter) const
double | distSqrToLine (const QPointF &start, const QPointF &end, const QPointF &point) const
Protected Functions inherited from QCPLayerable
virtual void | parentPlotInitialized (QCustomPlot *parentPlot)
void | initializeParentPlot (QCustomPlot *parentPlot)
void | setParentLayerable (QCPLayerable *parentLayerable)
bool | moveToLayer (QCPLayer *layer, bool prepend)
void | applyAntialiasingHint (QCPPainter *painter, bool localAntialiased, QCP::AntialiasedElement overrideElement) const

## Additional Inherited Members
Signals inherited from QCPAbstractPlottable
void | selectionChanged (bool selected)
void | selectableChanged (bool selectable)
Signals inherited from QCPLayerable
void | layerChanged (QCPLayer *newLayer)
Protected Types inherited from QCPAbstractPlottable
enum | SignDomain

## Detailed Description

A plottable representing a parametric curve in a plot.

Unlike QCPGraph, plottables of this type may have multiple points with the same key coordinate, so their visual representation can have loops. This is realized by introducing a third coordinate t, which defines the order of the points described by the other two coordinates x and y.

To plot data, assign it with the setData or addData functions.

Gaps in the curve can be created by adding data points with NaN as key and value (`qQNaN()` or `std::numeric_limits<double>::quiet_NaN()`) in between the two data points that shall be separated.

# Changing the appearance

The appearance of the curve is determined by the pen and the brush (setPen, setBrush).

# Usage

Like all data representing objects in QCustomPlot, the QCPCurve is a plottable (QCPAbstractPlottable). So the plottable-interface of QCustomPlot applies (QCustomPlot::plottable, QCustomPlot::addPlottable, QCustomPlot::removePlottable, etc.)

Usually, you first create an instance and add it to the customPlot:

QCPCurve *newCurve = new QCPCurve(customPlot->xAxis, customPlot->yAxis);
customPlot->addPlottable(newCurve);

and then modify the properties of the newly created plottable, e.g.:

newCurve->setName("Fermat's Spiral");
newCurve->setData(tData, xData, yData);

## Member Enumeration Documentation

enum QCPCurve::LineStyle

Defines how the curve's line is represented visually in the plot. The line is drawn with the current pen of the curve (setPen).

See Also
  setLineStyle

Enumerator
lsNone | No line is drawn between data points (e.g. only scatters)
lsLine | Data points are connected with a straight line.

## Constructor & Destructor Documentation

QCPCurve::QCPCurve | ( | QCPAxis * | keyAxis,
|  | QCPAxis * | valueAxis
| ) |  |
| explicit

Constructs a curve which uses keyAxis as its key axis ("x") and valueAxis as its value axis ("y"). keyAxis and valueAxis must reside in the same QCustomPlot instance and not have the same orientation. If either of these restrictions is violated, a corresponding message is printed to the debug output (qDebug), the construction is not aborted, though.

The constructed QCPCurve can be added to the plot with QCustomPlot::addPlottable, QCustomPlot then takes ownership of the graph.

## Member Function Documentation

void QCPCurve::setData | ( | QCPCurveDataMap * | data,
|  | bool | copy = `false`
| ) |  |

Replaces the current data with the provided data.

If copy is set to true, data points in data will only be copied. if false, the plottable takes ownership of the passed data and replaces the internal data pointer with it. This is significantly faster than copying for large datasets.

void QCPCurve::setData | ( | const QVector< double > & | t,
|  | const QVector< double > & | key,
|  | const QVector< double > & | value
| ) |  |

This is an overloaded function.

Replaces the current data with the provided points in t, key and value tuples. The provided vectors should have equal length. Else, the number of added points will be the size of the smallest vector.

void QCPCurve::setData | ( | const QVector< double > & | key,
|  | const QVector< double > & | value
| ) |  |

This is an overloaded function.

Replaces the current data with the provided key and value pairs. The t parameter of each data point will be set to the integer index of the respective key/value pair.

void QCPCurve::setScatterStyle | ( | const QCPScatterStyle & | style | ) |

Sets the visual appearance of single data points in the plot. If set to QCPScatterStyle::ssNone, no scatter points are drawn (e.g. for line-only plots with appropriate line style).

See Also
  QCPScatterStyle, setLineStyle

void QCPCurve::setLineStyle | ( | QCPCurve::LineStyle | style | ) |

Sets how the single data points are connected in the plot or how they are represented visually apart from the scatter symbol. For scatter-only plots, set style to lsNone and setScatterStyle to the desired scatter style.

See Also
  setScatterStyle

void QCPCurve::addData | ( | const QCPCurveDataMap & | dataMap | ) |

Adds the provided data points in dataMap to the current data.

See Also
  removeData

void QCPCurve::addData | ( | const QCPCurveData & | data | ) |

This is an overloaded function. Adds the provided single data point in data to the current data.

See Also
  removeData

void QCPCurve::addData | ( | double | t,
|  | double | key,
|  | double | value
| ) |  |

This is an overloaded function. Adds the provided single data point as t, key and value tuple to the current data

See Also
  removeData

void QCPCurve::addData | ( | double | key,
|  | double | value
| ) |  |

This is an overloaded function.

Adds the provided single data point as key and value pair to the current data The t parameter of the data point is set to the t of the last data point plus 1. If there is no last data point, t will be set to 0.

See Also
  removeData

void QCPCurve::addData | ( | const QVector< double > & | ts,
|  | const QVector< double > & | keys,
|  | const QVector< double > & | values
| ) |  |

This is an overloaded function. Adds the provided data points as t, key and value tuples to the current data.

See Also
  removeData

void QCPCurve::removeDataBefore | ( | double | t | ) |

Removes all data points with curve parameter t smaller than t.

See Also
  addData, clearData

void QCPCurve::removeDataAfter | ( | double | t | ) |

Removes all data points with curve parameter t greater than t.

See Also
  addData, clearData

void QCPCurve::removeData | ( | double | fromt,
|  | double | tot
| ) |  |

Removes all data points with curve parameter t between fromt and tot. if fromt is greater or equal to tot, the function does nothing. To remove a single data point with known t, use removeData(double t).

See Also
  addData, clearData

void QCPCurve::removeData | ( | double | t | ) |

This is an overloaded function.

Removes a single data point at curve parameter t. If the position is not known with absolute precision, consider using removeData(double fromt, double tot) with a small fuzziness interval around the suspected position, depeding on the precision with which the curve parameter is known.

See Also
  addData, clearData

void QCPCurve::clearData | ( |  | ) |
| virtual

Removes all data points.

See Also
  removeData, removeDataAfter, removeDataBefore

Implements QCPAbstractPlottable.

double QCPCurve::selectTest | ( | const QPointF & | pos,
|  | bool | onlySelectable,
|  | QVariant * | details = `0`
| ) |  | const
| virtual

This function is used to decide whether a click hits a layerable object or not.

pos is a point in pixel coordinates on the QCustomPlot surface. This function returns the shortest pixel distance of this point to the object. If the object is either invisible or the distance couldn't be determined, -1.0 is returned. Further, if onlySelectable is true and the object is not selectable, -1.0 is returned, too.

If the object is represented not by single lines but by an area like a QCPItemText or the bars of a QCPBars plottable, a click inside the area should also be considered a hit. In these cases this function thus returns a constant value greater zero but still below the parent plot's selection tolerance. (typically the selectionTolerance multiplied by 0.99).

Providing a constant value for area objects allows selecting line objects even when they are obscured by such area objects, by clicking close to the lines (i.e. closer than 0.99*selectionTolerance).

The actual setting of the selection state is not done by this function. This is handled by the parent QCustomPlot when the mouseReleaseEvent occurs, and the finally selected object is notified via the selectEvent/deselectEvent methods.

details is an optional output parameter. Every layerable subclass may place any information in details. This information will be passed to selectEvent when the parent QCustomPlot decides on the basis of this selectTest call, that the object was successfully selected. The subsequent call to selectEvent will carry the details. This is useful for multi-part objects (like QCPAxis). This way, a possibly complex calculation to decide which part was clicked is only done once in selectTest. The result (i.e. the actually clicked part) can then be placed in details. So in the subsequent selectEvent, the decision which part was selected doesn't have to be done a second time for a single selection operation.

You may pass 0 as details to indicate that you are not interested in those selection details.

See Also
  selectEvent, deselectEvent, QCustomPlot::setInteractions

Implements QCPAbstractPlottable.

void QCPCurve::draw | ( | QCPPainter * | painter | ) |
| protectedvirtual

This function draws the layerable with the specified painter. It is only called by QCustomPlot, if the layerable is visible (setVisible).

Before this function is called, the painter's antialiasing state is set via applyDefaultAntialiasingHint, see the documentation there. Further, the clipping rectangle was set to clipRect.

Implements QCPAbstractPlottable.

void QCPCurve::drawLegendIcon | ( | QCPPainter * | painter,
|  | const QRectF & | rect
| ) |  | const
| protectedvirtual

called by QCPLegend::draw (via QCPPlottableLegendItem::draw) to create a graphical representation of this plottable inside rect, next to the plottable name.

The passed painter has its cliprect set to rect, so painting outside of rect won't appear outside the legend icon border.

Implements QCPAbstractPlottable.

QCPRange QCPCurve::getKeyRange | ( | bool & | foundRange,
|  | SignDomain | inSignDomain = `sdBoth`
| ) |  | const
| protectedvirtual

called by rescaleAxes functions to get the full data key bounds. For logarithmic plots, one can set inSignDomain to either sdNegative or sdPositive in order to restrict the returned range to that sign domain. E.g. when only negative range is wanted, set inSignDomain to sdNegative and all positive points will be ignored for range calculation. For no restriction, just set inSignDomain to sdBoth (default). foundRange is an output parameter that indicates whether a range could be found or not. If this is false, you shouldn't use the returned range (e.g. no points in data).

Note that foundRange is not the same as QCPRange::validRange, since the range returned by this function may have size zero, which wouldn't count as a valid range.

See Also
  rescaleAxes, getValueRange

Implements QCPAbstractPlottable.

QCPRange QCPCurve::getValueRange | ( | bool & | foundRange,
|  | SignDomain | inSignDomain = `sdBoth`
| ) |  | const
| protectedvirtual

called by rescaleAxes functions to get the full data value bounds. For logarithmic plots, one can set inSignDomain to either sdNegative or sdPositive in order to restrict the returned range to that sign domain. E.g. when only negative range is wanted, set inSignDomain to sdNegative and all positive points will be ignored for range calculation. For no restriction, just set inSignDomain to sdBoth (default). foundRange is an output parameter that indicates whether a range could be found or not. If this is false, you shouldn't use the returned range (e.g. no points in data).

Note that foundRange is not the same as QCPRange::validRange, since the range returned by this function may have size zero, which wouldn't count as a valid range.

See Also
  rescaleAxes, getKeyRange

Implements QCPAbstractPlottable.

void QCPCurve::drawScatterPlot | ( | QCPPainter * | painter,
|  | const QVector< QPointF > * | pointData
| ) |  | const
| protectedvirtual

Draws scatter symbols at every data point passed in pointData. scatter symbols are independent of the line style and are always drawn if scatter shape is not QCPScatterStyle::ssNone.

void QCPCurve::getCurveData | ( | QVector< QPointF > * | lineData | ) | const
| protected

called by QCPCurve::draw to generate a point vector (in pixel coordinates) which represents the line of the curve.

Line segments that aren't visible in the current axis rect are handled in an optimized way. They are projected onto a rectangle slightly larger than the visible axis rect and simplified regarding point count. The algorithm makes sure to preserve appearance of lines and fills inside the visible axis rect by generating new temporary points on the outer rect if necessary.

Methods that are also involved in the algorithm are: getRegion, getOptimizedPoint, getOptimizedCornerPoints mayTraverse, getTraverse, getTraverseCornerPoints.

int QCPCurve::getRegion | ( | double | x,
|  | double | y,
|  | double | rectLeft,
|  | double | rectTop,
|  | double | rectRight,
|  | double | rectBottom
| ) |  | const
| protected

This function is part of the curve optimization algorithm of getCurveData.

It returns the region of the given point (x, y) with respect to a rectangle defined by rectLeft, rectTop, rectRight, and rectBottom.

The regions are enumerated from top to bottom and left to right:

1 | 4 | 7
2 | 5 | 8
3 | 6 | 9

With the rectangle being region 5, and the outer regions extending infinitely outwards. In the curve optimization algorithm, region 5 is considered to be the visible portion of the plot.

QPointF QCPCurve::getOptimizedPoint | ( | int | otherRegion,
|  | double | otherKey,
|  | double | otherValue,
|  | double | key,
|  | double | value,
|  | double | rectLeft,
|  | double | rectTop,
|  | double | rectRight,
|  | double | rectBottom
| ) |  | const
| protected

This function is part of the curve optimization algorithm of getCurveData.

This method is used in case the current segment passes from inside the visible rect (region 5, see getRegion) to any of the outer regions (otherRegion). The current segment is given by the line connecting (key, value) with (otherKey, otherValue).

It returns the intersection point of the segment with the border of region 5.

For this function it doesn't matter whether (key, value) is the point inside region 5 or whether it's (otherKey, otherValue), i.e. whether the segment is coming from region 5 or leaving it. It is important though that otherRegion correctly identifies the other region not equal to 5.

QVector< QPointF > QCPCurve::getOptimizedCornerPoints | ( | int | prevRegion,
|  | int | currentRegion,
|  | double | prevKey,
|  | double | prevValue,
|  | double | key,
|  | double | value,
|  | double | rectLeft,
|  | double | rectTop,
|  | double | rectRight,
|  | double | rectBottom
| ) |  | const
| protected

This function is part of the curve optimization algorithm of getCurveData.

In situations where a single segment skips over multiple regions it might become necessary to add extra points at the corners of region 5 (see getRegion) such that the optimized segment doesn't unintentionally cut through the visible area of the axis rect and create plot artifacts. This method provides these points that must be added, assuming the original segment doesn't start, end, or traverse region 5. (Corner points where region 5 is traversed are calculated by getTraverseCornerPoints.)

For example, consider a segment which directly goes from region 4 to 2 but originally is far out to the top left such that it doesn't cross region 5. Naively optimizing these points by projecting them on the top and left borders of region 5 will create a segment that surely crosses 5, creating a visual artifact in the plot. This method prevents this by providing extra points at the top left corner, making the optimized curve correctly pass from region 4 to 1 to 2 without traversing 5.

bool QCPCurve::mayTraverse | ( | int | prevRegion,
|  | int | currentRegion
| ) |  | const
| protected

This function is part of the curve optimization algorithm of getCurveData.

This method returns whether a segment going from prevRegion to currentRegion (see getRegion) may traverse the visible region 5. This function assumes that neither prevRegion nor currentRegion is 5 itself.

If this method returns false, the segment for sure doesn't pass region 5. If it returns true, the segment may or may not pass region 5 and a more fine-grained calculation must be used (getTraverse).

bool QCPCurve::getTraverse | ( | double | prevKey,
|  | double | prevValue,
|  | double | key,
|  | double | value,
|  | double | rectLeft,
|  | double | rectTop,
|  | double | rectRight,
|  | double | rectBottom,
|  | QPointF & | crossA,
|  | QPointF & | crossB
| ) |  | const
| protected

This function is part of the curve optimization algorithm of getCurveData.

This method assumes that the mayTraverse test has returned true, so there is a chance the segment defined by (prevKey, prevValue) and (key, value) goes through the visible region 5.

The return value of this method indicates whether the segment actually traverses region 5 or not.

If the segment traverses 5, the output parameters crossA and crossB indicate the entry and exit points of region 5. They will become the optimized points for that segment.

void QCPCurve::getTraverseCornerPoints | ( | int | prevRegion,
|  | int | currentRegion,
|  | double | rectLeft,
|  | double | rectTop,
|  | double | rectRight,
|  | double | rectBottom,
|  | QVector< QPointF > & | beforeTraverse,
|  | QVector< QPointF > & | afterTraverse
| ) |  | const
| protected

This function is part of the curve optimization algorithm of getCurveData.

This method assumes that the getTraverse test has returned true, so the segment definitely traverses the visible region 5 when going from prevRegion to currentRegion.

In certain situations it is not sufficient to merely generate the entry and exit points of the segment into/out of region 5, as getTraverse provides. It may happen that a single segment, in addition to traversing region 5, skips another region outside of region 5, which makes it necessary to add an optimized corner point there (very similar to the job getOptimizedCornerPoints does for segments that are completely in outside regions and don't traverse 5).

As an example, consider a segment going from region 1 to region 6, traversing the lower left corner of region 5. In this configuration, the segment additionally crosses the border between region 1 and 2 before entering region 5. This makes it necessary to add an additional point in the top left corner, before adding the optimized traverse points. So in this case, the output parameter beforeTraverse will contain the top left corner point, and afterTraverse will be empty.

In some cases, such as when going from region 1 to 9, it may even be necessary to add additional corner points before and after the traverse. Then both beforeTraverse and afterTraverse return the respective corner points.

double QCPCurve::pointDistance | ( | const QPointF & | pixelPoint | ) | const
| protected

Calculates the (minimum) distance (in pixels) the curve's representation has from the given pixelPoint in pixels. This is used to determine whether the curve was clicked or not, e.g. in selectTest.

The documentation for this class was generated from the following files:

- src/plottables/plottable-curve.h
- src/plottables/plottable-curve.cpp